-- principal 4 genera las dos soluciones en el archivo out.txt
-- principal 8 genera las 92 soluciones en el archivo out.txt
-- principal n genera todas las solucines en el archivo out.txt

reinas :: Int -> [Int] -> [Int] -> [Int] -> [[Int]]
reinas n js bs ss = 
  let i = length js
  in if i == n
     then [reverse js]
     else concat $ map (\j -> let b = i - j
                                  s = i + j
                              in if j `notElem` js && b `notElem` bs && s `notElem` ss
                                 then reinas n (j:js) (b:bs) (s:ss)
                                 else [])
                       [1..n]

filavacia :: String
filavacia = repeat '.'

vacio :: Int -> String
vacio i = take i filavacia

fila :: Int -> Int -> String
fila n j = vacio (j-1) ++ "Q" ++ vacio (n-j)

tablero :: [Int] -> [String]
tablero js = "" : map (fila (length js)) js

principal n = writeFile "out.txt" $ unlines $ concat $ map tablero (reinas n [] [] []) 

aLetras :: [Int] -> [String]
aLetras [i1,i2,i3,i4,i5,i6,i7,i8] = ["a"++aLetra i1,"b"++aLetra i2,"c"++aLetra i3,"d"++aLetra i4,"e"++aLetra i5,"f"++aLetra i6,"g"++aLetra i7,"h"++aLetra i8]

aLetra :: Int -> String
aLetra 1 = "a"
aLetra 2 = "b"
aLetra 3 = "c"
aLetra 4 = "d"
aLetra 5 = "e"
aLetra 6 = "f"
aLetra 7 = "g"
aLetra 8 = "h"

formato :: [String] -> String
formato [xy] = xy ++ "/1"
formato (xy:xys) = xy ++ "/1," ++ formato xys

cabeza = "\\begin{frame}\\frametitle{Ocho reinas, todas las soluciones}\\tikzstyle{bs}=[rectangle,fill=black!50,minimum size=20pt,inner sep=0pt]\\tikzstyle{ws}=[rectangle,fill=black!15,minimum size=20pt,inner sep=0pt]\\begin{figure}\\begin{tikzpicture}[scale=1.8, auto,swap]    \\foreach \\pos/\\name/\\sq in        {{(0,2)/aa/bs}, {(0.4,2)/ab/ws}, {(0.8,2)/ac/bs}, {(1.2,2)/ad/ws}, {(1.6,2)/ae/bs}, {(2,2)/af/ws}, {(2.4,2)/ag/bs}, {(2.8,2)/ah/ws},         {(0,1.6)/ba/ws}, {(0.4,1.6)/bb/bs}, {(0.8,1.6)/bc/ws}, {(1.2,1.6)/bd/bs}, {(1.6,1.6)/be/ws}, {(2,1.6)/bf/bs}, {(2.4,1.6)/bg/ws}, {(2.8,1.6)/bh/bs},         {(0,1.2)/ca/bs}, {(0.4,1.2)/cb/ws}, {(0.8,1.2)/cc/bs}, {(1.2,1.2)/cd/ws}, {(1.6,1.2)/ce/bs}, {(2,1.2)/cf/ws}, {(2.4,1.2)/cg/bs}, {(2.8,1.2)/ch/ws},         {(0,0.8)/da/ws}, {(0.4,0.8)/db/bs}, {(0.8,0.8)/dc/ws}, {(1.2,0.8)/dd/bs}, {(1.6,0.8)/de/ws}, {(2,0.8)/df/bs}, {(2.4,0.8)/dg/ws}, {(2.8,0.8)/dh/bs},         {(0,0.4)/ea/bs}, {(0.4,0.4)/eb/ws}, {(0.8,0.4)/ec/bs}, {(1.2,0.4)/ed/ws}, {(1.6,0.4)/ee/bs}, {(2,0.4)/ef/ws}, {(2.4,0.4)/eg/bs}, {(2.8,0.4)/eh/ws},         {(0,0)/fa/ws}, {(0.4,0)/fb/bs}, {(0.8,0)/fc/ws}, {(1.2,0)/fd/bs}, {(1.6,0)/fe/ws}, {(2,0)/ff/bs}, {(2.4,0)/fg/ws}, {(2.8,0)/fh/bs},         {(0,-0.4)/ga/bs}, {(0.4,-0.4)/gb/ws}, {(0.8,-0.4)/gc/bs}, {(1.2,-0.4)/gd/ws}, {(1.6,-0.4)/ge/bs}, {(2,-0.4)/gf/ws}, {(2.4,-0.4)/gg/bs}, {(2.8,-0.4)/gh/ws},         {(0,-0.8)/ha/ws}, {(0.4,-0.8)/hb/bs}, {(0.8,-0.8)/hc/ws}, {(1.2,-0.8)/hd/bs}, {(1.6,-0.8)/he/ws}, {(2,-0.8)/hf/bs}, {(2.4,-0.8)/hg/ws}, {(2.8,-0.8)/hh/bs}}        \\node[\\sq] (\\name) at \\pos {$ $};     \\foreach \\vertex/\\fr in {"

cola = "}         \\path<\\fr-> node at (\\vertex) {Q};\\end{tikzpicture}\\end{figure}\\end{frame}"

ppal = unlines $ map (\f -> cabeza ++ f ++ cola) $ map formato $ map aLetras $ reinas 8 [] [] []

